
package com.roshka.webprojecttest.servlets;

import java.math.BigInteger;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@WebServlet("/factorial")
public class FactorialServlet extends HttpServlet {
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException
	{
		System.out.println("dentro del doGet");
		PrintWriter pw = new PrintWriter(resp.getOutputStream());
		Boolean valido=true;
		String parametro =  req.getParameter("number");
		if(parametro == null  ) {
			initForm(pw);
		}
		else {
			
			if(parametro.equals(""))
				valido=false;
			for(int i = 0 ; i < parametro.length(); i++) {
				if(  ( !Character.isDigit(parametro.charAt(i)) && i > 0) && !(Character.isDigit(parametro.charAt(i)) && i == 0 && parametro.charAt(i) != '-' )  ) {
					valido=false;
					break;
				}
			}
			if (!valido) {
				error(pw, parametro);
			}
			else {
				Integer numero = Integer.parseInt(parametro);
				if(numero > 100) {
					greaterThan100(pw, numero);
				}
				else if(numero<0) {
					negative(pw);
				}
				else{
					BigInteger facto =  BigInteger.ONE;
					for (Integer i = 2; i <=numero; i++) {
						facto = facto.multiply(new BigInteger(i.toString()));
						System.out.printf("factoActual[%d]: ", i, facto );
					}
					factoDisplay(pw, numero, facto);				
				}
			}
		}
		pw.close();
	}
	
	void factoDisplay(PrintWriter pw, Integer numero, BigInteger facto) {
		System.out.println("dentro del factoDisplay");
		pw.write("<html>"
				+ "<head>"
				+ "<title>Hola, bienvenidos al factorializador</title>"
				+ "</head>"
				+ "<body>"
				+ "<h1>Soy un generador de factorial de numeros</h1>"
				+ "<div>"
				+ "<form action=\"factorial\"  method=\"get\">"
				+ "Introduzca el numero: <input type=\"text\"  name=number><br>"
				+ "<input type=\"submit\">"
				+ "</form>"
				+ "</div>"
				+ "<div>"
				+ "<p>El factorial de "+ numero+" es: " + facto.toString() +"</p>"
				+ "</div>"
				+ "</body>"
				+ "</html>");
	}
	
	void error(PrintWriter pw, String parametro) {
		pw.write("<html>"
				+ "<head>"
				+ "<title>Error de parametro</title>"
				+ "</head>"
				+ "<body>"
				+ "No se puede generarla tabla de multiplicar. Valor del parametro \" " + parametro + " \" invalido."
				+ "</body>"
				+ "</html>");
	}
	void greaterThan100(PrintWriter pw, Integer numero) {
		pw.write("<html>"
				+ "<head>"
				+ "<title>Error de parametro</title>"
				+ "</head>"
				+ "<body>"
				+ "Mi programa solo conoce el factorial de hasta el numero 100. El numero pasado fue: "+numero
				+ "</body>"
				+ "</html>");
		
	}
	void negative(PrintWriter pw) {
		pw.write("<html>"
				+ "<head>"
				+ "<title>Error de parametro</title>"
				+ "</head>"
				+ "<body>"
				+ "Mi programa no sabe obtener el factorial de numeros negativos"
				+ "</body>"
				+ "</html>");
	}
	void initForm(PrintWriter pw) {
		pw.write("<html>"
				+ "<head>"
				+ "<title>Hola, bienvenidos factorializador</title>"
				+ "</head>"
				+ "<body>"
				+ "<h1>Soy un factorializador</h1>"
				+ "<div>"
				+ "<form action=\"factorial\" method=\"get\" >"
				+ "Introduzca el numero: <input type=\"text\"  name=number><br>"
				+ "<input type=\"submit\">"
				+ "</form>"
				+ "</div>"
				+ "</body>"
				+ "</html>");

	}
}

